## vixl 5.1.0

=== SConstruct ===
# Copyright 2015, VIXL authors
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#   * Redistributions of source code must retain the above copyright notice,
#     this list of conditions and the following disclaimer.
#   * Redistributions in binary form must reproduce the above copyright notice,
#     this list of conditions and the following disclaimer in the documentation
#     and/or other materials provided with the distribution.
#   * Neither the name of ARM Limited nor the names of its contributors may be
#     used to endorse or promote products derived from this software without
#     specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

import glob
import itertools
import os
from os.path import join
import platform
import subprocess
import sys
from collections import OrderedDict

root_dir = os.path.dirname(File('SConstruct').rfile().abspath)
sys.path.insert(0, join(root_dir, 'tools'))
import config
import util

from SCons.Errors import UserError


Help('''
Build system for the VIXL project.
See README.md for documentation and details about the build system.
''')


# We track top-level targets to automatically generate help and alias them.
class VIXLTargets:
  def __init__(self):
    self.targets = []
    self.help_messages = []
  def Add(self, target, help_message):
    self.targets.append(target)
    self.help_messages.append(help_message)
  def Help(self):
    res = ""
    for i in range(len(self.targets)):
      res += '\t{0:<{1}}{2:<{3}}\n'.format(
        'scons ' + self.targets[i],
        len('scons ') + max(map(len, self.targets)),
        ' : ' + self.help_messages[i],
        len(' : ') + max(map(len, self.help_messages)))
    return res

top_level_targets = VIXLTargets()



# Build options ----------------------------------------------------------------

# Store all the options in a dictionary.
# The SConstruct will check the build variables and construct the build
# environment as appropriate.
options = {
    'all' : { # Unconditionally processed.
      'CCFLAGS' : ['-Wall',
                   '-Werror',
                   '-fdiagnostics-show-option',
                   '-Wextra',
                   '-Wredundant-decls',
                   '-pedantic',
                   '-Wwrite-strings',
                   '-Wunused',
                   '-Wno-missing-noreturn'],
      'CPPPATH' : [config.dir_src_vixl]
      },
#   'build_option:value' : {
#     'environment_key' : 'values to append'
#     },
    'mode:debug' : {
      'CCFLAGS' : ['-DVIXL_DEBUG', '-O0']
      },
    'mode:release' : {
      'CCFLAGS' : ['-O3'],
      },
    'simulator:aarch64' : {
      'CCFLAGS' : ['-DVIXL_INCLUDE_SIMULATOR_AARCH64'],
      },
    'symbols:on' : {
      'CCFLAGS' : ['-g'],
      'LINKFLAGS' : ['-g']
      },
    'negative_testing:on' : {
      'CCFLAGS' : ['-DVIXL_NEGATIVE_TESTING']
      },
    'code_buffer_allocator:mmap' : {
      'CCFLAGS' : ['-DVIXL_CODE_BUFFER_MMAP']
      },
    'code_buffer_allocator:malloc' : {
      'CCFLAGS' : ['-DVIXL_CODE_BUFFER_MALLOC']
      },
    'ubsan:on' : {
      'CCFLAGS': ['-fsanitize=undefined'],
      'LINKFLAGS': ['-fsanitize=undefined']
      }
    }


# A `DefaultVariable` has a default value that depends on elements not known
# when variables are first evaluated.
# Each `DefaultVariable` has a handler that will compute the default value for
# the given environment.
def modifiable_flags_handler(env):
  env['modifiable_flags'] = \
      'on' if 'mode' in env and env['mode'] == 'debug' else 'off'


def symbols_handler(env):
  env['symbols'] = 'on' if 'mode' in env and env['mode'] == 'debug' else 'off'

def Is32BitHost(env):
  return env['host_arch'] in ['aarch32', 'i386']

def IsAArch64Host(env):
  return env['host_arch'] == 'aarch64'

def CanTargetA32(env):
  return 'a32' in env['target']

def CanTargetT32(env):
  return 't32' in env['target']

def CanTargetAArch32(env):
  return CanTargetA32(env) or CanTargetT32(env)

def CanTargetA64(env):
  return 'a64' in env['target']

def CanTargetAArch64(env):
  return CanTargetA64(env)


# By default, include the simulator only if AArch64 is targeted and we are not
# building VIXL natively for AArch64.
def simulator_handler(env):
  if not IsAArch64Host(env) and CanTargetAArch64(env):
    env['simulator'] = 'aarch64'
  else:
    env['simulator'] = 'none'


# 'mmap' is required for use with 'mprotect', which is needed for the tests
# (when running natively), so we use it by default where we can.
def code_buffer_allocator_handler(env):
  directives = util.GetCompilerDirectives(env)
  if '__linux__' in directives:
    env['code_buffer_allocator'] = 'mmap'
  else:
    env['code_buffer_allocator'] = 'malloc'

# A validator checks the consistency of provided options against the environment.
def default_validator(env):
  pass


def simulator_validator(env):
  if env['simulator'] == 'aarch64' and not CanTargetAArch64(env):
    raise UserError('Building an AArch64 simulator implies that VIXL targets '
                    'AArch64. Set `target` to include `aarch64` or `a64`.')


# Default variables may depend on each other, therefore we need this dictionnary
# to be ordered.
vars_default_handlers = OrderedDict({
    # variable_name    : [ 'default val', 'handler', 'validator']
    'symbols'          : [ 'mode==debug', symbols_handler, default_validator ],
    'modifiable_flags' : [ 'mode==debug', modifiable_flags_handler, default_validator],
    'simulator'        : [ 'on if the target architectures include AArch64 but '
                           'the host is not AArch64, else off',
                           simulator_handler, simulator_validator ],
    'code_buffer_allocator' : [ 'mmap with __linux__, malloc otherwise',
                                code_buffer_allocator_handler, default_validator ]
    })


def DefaultVariable(name, help, allowed_values):
  help = '%s (%s)' % (help, '|'.join(allowed_values))
  default_value = vars_default_handlers[name][0]
  def validator(name, value, env):
    if value != default_value and value not in allowed_values:
        raise UserError('Invalid value for option {name}: {value}.  '
                        'Valid values are: {allowed_values}'.format(
                            name, value, allowed_values))
  return (name, help, default_value, validator)


def SortListVariable(iterator):
  # Previously this code relied on the order of items in a list
  # converted from a set. However in Python 3 the order changes each run.
  # Here we do a custom partial sort to ensure that the build directory
  # name is stable, the same across Python 2 and 3, and the same as the
  # old code.
  result = list(sorted(iterator))
  result = sorted(result, key=lambda x: x == 't32', reverse=True)
  result = sorted(result, key=lambda x: x == 'a32', reverse=True)
  result = sorted(result, key=lambda x: x == 'a64', reverse=True)
  return result


def AliasedListVariable(name, help, default_value, allowed_values, aliasing):
  help = '%s (all|auto|comma-separated list) (any combination from [%s])' % \
         (help, ', '.join(allowed_values))

  def validator(name, value, env):
    # Here list has been converted to space separated strings.
    if value == '': return  # auto
    for v in value.split():
      if v not in allowed_values:
        raise UserError('Invalid value for %s: %s' % (name, value))

  def converter(value):
    if value == 'auto': return []
    if value == 'all':
      translated = [aliasing[v] for v in allowed_values]
      return SortListVariable(itertools.chain.from_iterable(translated))
    # The validator is run later hence the get.
    translated = [aliasing.get(v, v) for v in value.split(',')]
    return SortListVariable(itertools.chain.from_iterable(translated))

  return (name, help, default_value, validator, converter)


vars = Variables()
# Define command line build options.
vars.AddVariables(
    AliasedListVariable('target', 'Target ISA/Architecture', 'auto',
                        ['aarch32', 'a32', 't32', 'aarch64', 'a64'],
                        {'aarch32' : ['a32', 't32'],
                         'a32' : ['a32'], 't32' : ['t32'],
                         'aarch64' : ['a64'], 'a64' : ['a64']}),
    EnumVariable('mode', 'Build mode',
                 'release', allowed_values=config.build_options_modes),
    EnumVariable('ubsan', 'Enable undefined behavior checks',
                 'off', allowed_values=['on', 'off']),
    EnumVariable('negative_testing',
                  'Enable negative testing (needs exceptions)',
                 'off', allowed_values=['on', 'off']),
    DefaultVariable('symbols', 'Include debugging symbols in the binaries',
                    ['on', 'off']),
    DefaultVariable('simulator', 'Simulators to include', ['aarch64', 'none']),
    DefaultVariable('code_buffer_allocator',
                    'Configure the allocation mechanism in the CodeBuffer',
                    ['malloc', 'mmap']),
    ('std',
     'C++ standard. The standards tested are: %s.' % \
     ', '.join(config.tested_cpp_standards),
     config.tested_cpp_standards[0]),
    ('compiler_wrapper', 'Command to prefix to the C and C++ compiler (e.g ccache)', '')
    )

# We use 'variant directories' to avoid recompiling multiple times when build
# options are changed, different build paths are used depending on the options
# set. These are the options that should be reflected in the build directory
# path.
options_influencing_build_path = [
  'target', 'mode', 'symbols', 'compiler', 'std', 'simulator', 'negative_testing',
  'code_buffer_allocator'
]



# Build helpers ----------------------------------------------------------------

def RetrieveEnvironmentVariables(env):
  for key in ['CC', 'CXX', 'AR', 'RANLIB', 'LD']:
    if os.getenv(key): env[key] = os.getenv(key)
  if os.getenv('LD_LIBRARY_PATH'): env['LIBPATH'] = os.getenv('LD_LIBRARY_PATH')
  if os.getenv('CCFLAGS'):
    env.Append(CCFLAGS = os.getenv('CCFLAGS').split())
  if os.getenv('CXXFLAGS'):
    env.Append(CXXFLAGS = os.getenv('CXXFLAGS').split())
  if os.getenv('LINKFLAGS'):
    env.Append(LINKFLAGS = os.getenv('LINKFLAGS').split())

# The architecture targeted by default will depend on the compiler being
# used. 'host_arch' is extracted from the compiler while 'target' can be
# set by the user.
# By default, we target both AArch32 and AArch64 unless the compiler targets a
# 32-bit architecture. At the moment, we cannot build VIXL's AArch64 support on
# a 32-bit platform.
# TODO: Port VIXL to build on a 32-bit platform.
def target_handler(env):
  # Auto detect
  if Is32BitHost(env):
    # We use list(set(...)) to keep the same order as if it was specify as
    # an option.
    env['target'] = SortListVariable(['a32', 't32'])
  else:
    env['target'] = SortListVariable(['a64', 'a32', 't32'])


def target_validator(env):
  # TODO: Port VIXL64 to work on a 32-bit platform.
  if Is32BitHost(env) and CanTargetAArch64(env):
    raise UserError('Building VIXL for AArch64 in 32-bit is not supported. Set '
                    '`target` to `aarch32`')


# The target option is handled differently from the rest.

=== debian/changelog ===
vixl (5.1.0-6) unstable; urgency=medium

  * d/control: fix markdown build dependency

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 08 Aug 2024 22:23:25 +0200

vixl (5.1.0-5) unstable; urgency=medium

  * First dgit upload
  * d/gbp.conf: switch to git-debrebase
  * d/README.source: document packaging workflow

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 07 Aug 2024 00:20:32 +0200

vixl (5.1.0-4) unstable; urgency=medium

  * d/control: mark markdown deps with :all
  * d/patches: fix FTBFS with GCC 14 (Closes: #1075625)
  * d/watch: use GitHub's API

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 06 Aug 2024 23:44:55 +0200

vixl (5.1.0-3) unstable; urgency=medium

  * d/control: add Vcs fields
  * d/control: Build-Depend on libtext-markdown-perl or markdown
  * d/patches: update patches to latest revision

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 13 Jan 2022 12:24:36 +0100

vixl (5.1.0-2) unstable; urgency=medium

  * Patch: do not force HARDFLOAT when using soft fp (fix armel build)

 -- Andrea Pappacoda <andrea@pappacoda.it>  Mon, 22 Nov 2021 21:49:20 +0100

vixl (5.1.0-1) unstable; urgency=low

  * Initial release. Closes: #996576

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 14 Oct 2021 21:47:08 +0200

=== debian/control ===
Source: vixl
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends: debhelper-compat (= 13), meson (>= 0.49.0)
Build-Depends-Arch: discount | markdown
Standards-Version: 4.6.0
Homepage: https://github.com/Linaro/vixl
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debian/vixl.git
Vcs-Browser: https://salsa.debian.org/debian/vixl

Package: libvixl5
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: ARMv8 Runtime Code Generation Library
 Vixl is an AArch32 and AArch64 Runtime Code Generation Library.
 .
 It contains three components: assemblers to generate ARM code at runtime,
 disassemblers that can print any instruction emitted by the assemblers and
 a simulator that can simulate any instruction emitted by the A64 assembler.
 .
 This package contains the shared library.

Package: libvixl-dev
Section: libdevel
Architecture: any
Depends: libvixl5 (= ${binary:Version}), ${misc:Depends}
Description: ARMv8 Runtime Code Generation Library - develop
 Vixl is an AArch32 and AArch64 Runtime Code Generation Library.
 .
 It contains three components: assemblers to generate ARM code at runtime,
 disassemblers that can print any instruction emitted by the assemblers and
 a simulator that can simulate any instruction emitted by the A64 assembler.
 .
 This package contains the development files.

=== debian/watch ===
version=4
opts="searchmode=plain, \
  filenamemangle=s/@ANY_VERSION@/@PACKAGE@-$1\.tar\.gz/, \
  pgpmode=none" \
https://api.github.com/repos/Linaro/vixl/tags \
https://api.github.com/repos/Linaro/vixl/tarball/refs/tags/@ANY_VERSION@

## vixl 7.0.0

=== debian/changelog ===
vixl (7.0.0-1) experimental; urgency=medium

  * Update to new upstream version 7.0.0.
  * d/control: libvixl5 -> libvixl7
  * d/control: declare dpkg-build-api = 1
  * d/control: prefer markdown to discount.
    Discount has some minor differences in output which might affect
    negatively the produced HTML. Since upstream suggests installing the
    "markdown" program, do that if possible, falling back to discount.
  * d/patches: update Meson patch

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sat, 10 Aug 2024 23:30:27 +0200

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,14 @@
 Section: libs
 Priority: optional
 Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
-Build-Depends: debhelper-compat (= 13), meson (>= 0.49.0)
-Build-Depends-Arch: discount | markdown
-Standards-Version: 4.6.0
+Build-Depends: debhelper-compat (= 13), dpkg-build-api (= 1), meson (>= 0.50.0)
+Build-Depends-Arch: markdown | discount
+Standards-Version: 4.7.0
 Homepage: https://github.com/Linaro/vixl
-Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/debian/vixl.git
 Vcs-Browser: https://salsa.debian.org/debian/vixl
 
-Package: libvixl5
+Package: libvixl7
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
@@ -26,7 +25,7 @@
 Package: libvixl-dev
 Section: libdevel
 Architecture: any
-Depends: libvixl5 (= ${binary:Version}), ${misc:Depends}
+Depends: libvixl7 (= ${binary:Version}), ${misc:Depends}
 Description: ARMv8 Runtime Code Generation Library - develop
  Vixl is an AArch32 and AArch64 Runtime Code Generation Library.
  .

## vixl 8.0.0

=== SConstruct ===
--- 
+++ 
@@ -84,6 +84,7 @@
                    '-pedantic',
                    '-Wwrite-strings',
                    '-Wunused',
+                   '-Wshadow',
                    '-Wno-missing-noreturn'],
       'CPPPATH' : [config.dir_src_vixl]
       },
@@ -97,7 +98,9 @@
       'CCFLAGS' : ['-O3'],
       },
     'simulator:aarch64' : {
-      'CCFLAGS' : ['-DVIXL_INCLUDE_SIMULATOR_AARCH64'],
+      'CCFLAGS' : ['-DVIXL_INCLUDE_SIMULATOR_AARCH64',
+                   '-pthread'],
+      'LINKFLAGS' : ['-pthread']
       },
     'symbols:on' : {
       'CCFLAGS' : ['-g'],
@@ -115,6 +118,13 @@
     'ubsan:on' : {
       'CCFLAGS': ['-fsanitize=undefined'],
       'LINKFLAGS': ['-fsanitize=undefined']
+      },
+    'coverage:on' : {
+      'CCFLAGS': ['-fprofile-instr-generate', '-fcoverage-mapping'],
+      'LINKFLAGS': ['-fprofile-instr-generate', '-fcoverage-mapping']
+      },
+    'implicit_checks:on' : {
+      'CCFLAGS' : ['-DVIXL_ENABLE_IMPLICIT_CHECKS'],
       }
     }
 
@@ -182,7 +192,7 @@
                     'AArch64. Set `target` to include `aarch64` or `a64`.')
 
 
-# Default variables may depend on each other, therefore we need this dictionnary
+# Default variables may depend on each other, therefore we need this dictionary
 # to be ordered.
 vars_default_handlers = OrderedDict({
     # variable_name    : [ 'default val', 'handler', 'validator']
@@ -255,8 +265,14 @@
                  'release', allowed_values=config.build_options_modes),
     EnumVariable('ubsan', 'Enable undefined behavior checks',
                  'off', allowed_values=['on', 'off']),
+    EnumVariable('coverage', 'Enable code coverage measurement',
+                 'off', allowed_values=['on', 'off']),
     EnumVariable('negative_testing',
                   'Enable negative testing (needs exceptions)',
+                 'off', allowed_values=['on', 'off']),
+    EnumVariable('implicit_checks',
+                 'Allow signals raised from simulated invalid (e.g: out of'
+                 + ' bounds) memory reads to be handled by the host.',
                  'off', allowed_values=['on', 'off']),
     DefaultVariable('symbols', 'Include debugging symbols in the binaries',
                     ['on', 'off']),
@@ -299,24 +315,3 @@
 # used. 'host_arch' is extracted from the compiler while 'target' can be
 # set by the user.
 # By default, we target both AArch32 and AArch64 unless the compiler targets a
-# 32-bit architecture. At the moment, we cannot build VIXL's AArch64 support on
-# a 32-bit platform.
-# TODO: Port VIXL to build on a 32-bit platform.
-def target_handler(env):
-  # Auto detect
-  if Is32BitHost(env):
-    # We use list(set(...)) to keep the same order as if it was specify as
-    # an option.
-    env['target'] = SortListVariable(['a32', 't32'])
-  else:
-    env['target'] = SortListVariable(['a64', 'a32', 't32'])
-
-
-def target_validator(env):
-  # TODO: Port VIXL64 to work on a 32-bit platform.
-  if Is32BitHost(env) and CanTargetAArch64(env):
-    raise UserError('Building VIXL for AArch64 in 32-bit is not supported. Set '
-                    '`target` to `aarch32`')
-
-
-# The target option is handled differently from the rest.

=== debian/changelog ===
vixl (8.0.0-1) experimental; urgency=medium

  * Update to new upstream version 8.0.0.
  * Update Meson patch
  * d/control: libvixl7 -> libvixl8
  * d/control: use my @debian.org email address

 -- Andrea Pappacoda <tachi@debian.org>  Sat, 22 Mar 2025 18:25:25 +0100

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,26 @@
 Source: vixl
 Section: libs
 Priority: optional
-Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
-Build-Depends: debhelper-compat (= 13), dpkg-build-api (= 1), meson (>= 0.50.0)
-Build-Depends-Arch: markdown | discount
-Standards-Version: 4.7.0
+Maintainer: Andrea Pappacoda <tachi@debian.org>
+Build-Depends:
+ debhelper-compat (= 13),
+ dpkg-build-api (= 1),
+Build-Depends-Arch:
+ markdown | discount,
+ meson (>= 0.50.0),
+Standards-Version: 4.7.2
 Homepage: https://github.com/Linaro/vixl
 Vcs-Git: https://salsa.debian.org/debian/vixl.git
 Vcs-Browser: https://salsa.debian.org/debian/vixl
+X-Style: black
 
-Package: libvixl7
+Package: libvixl8
 Architecture: any
-Pre-Depends: ${misc:Pre-Depends}
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Pre-Depends:
+ ${misc:Pre-Depends},
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: ARMv8 Runtime Code Generation Library
  Vixl is an AArch32 and AArch64 Runtime Code Generation Library.
  .
@@ -25,7 +33,9 @@
 Package: libvixl-dev
 Section: libdevel
 Architecture: any
-Depends: libvixl7 (= ${binary:Version}), ${misc:Depends}
+Depends:
+ libvixl8 (= ${binary:Version}),
+ ${misc:Depends},
 Description: ARMv8 Runtime Code Generation Library - develop
  Vixl is an AArch32 and AArch64 Runtime Code Generation Library.
  .

=== debian/tests/control ===
Tests:
 build-examples,
Depends:
 dpkg-dev,
 g++ | c++-compiler,
 libc6-dev | libc-dev,
 pkg-config,
 @,
